/*frcvlab 2011
 *
 *file history
 *
 * dml spring 2011 - original file
 * sdf summer 2011 - modified to dump to pcd file type directly;
 * corrects error with PointXYZRGBA; we use PointXYZRGB directly and
 * do not have to worry about the bit shift for packing the rgb info
 * 
 * proposed modifications: 
 *
 * index the points to image coordinates
 * create our own point type that maintains disparity
 * 
 */

#include <iostream>
#include "pcl/io/pcd_io.h"
#include "pcl/point_types.h"

#include <stdio.h>

FILE *in,*out;

struct mypoint {
	double x,y,z;
	int r,g,b;
} p;

int numPoints=0;

int rgba(int r, int g, int b) {
	return r+256*g +256*256*b;
}

void doHeader(FILE *h, int nP) {
	
        fprintf(h,"# Point Cloud Data (PCD) file format v.5\n");
		fprintf(h,"FIELDS x y z rgba\n");
		fprintf(h,"SIZE 4 4 4 4\n");
		fprintf(h,"WIDTH %d\n",nP);
		fprintf(h,"HEIGHT 1\n");
		fprintf(h,"POINTS %d\n",nP);
		fprintf(h,"DATA ascii\n");
}

int main(int argc, char **argv) {
  int u,v,d;
	if (argc!=3) {
		 printf("command line arguments infile, outfile missing\n");
		 return(0);
	}
    printf("Translating point cloud format in %s to %s.\n",argv[1],argv[2]);
	in = fopen(argv[1],"r");
	out=fopen(argv[2],"w");

	

	while (fscanf(in,"%lf, %lf, %lf, %d, %d, %d, %d, %d, %d\n",
			&p.x, &p.y, &p.z, &u, &v, &d, &p.r, &p.g, &p.b)!=EOF /*&& k<320*240*/) {
				numPoints++;
	}
	fclose(in);
	printf("%d points to be converted\n",numPoints);


	in = fopen(argv[1],"r"); 

	pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGB>);

	cloud->width = numPoints;
	cloud->height = 1;
	cloud->points.resize(numPoints);

	//      	doHeader(out,numPoints);

	int i=0;
	while (fscanf(in,"%lf, %lf, %lf, %d, %d, %d, %d, %d, %d\n",
		      &p.x, &p.y, &p.z, &u, &v, &d, &p.r, &p.g, &p.b)!=EOF /*&& k<320*240*/) {
	  pcl::PointXYZRGB& pt = cloud->points[i];
	  pt.x = p.x;
	  pt.y = p.y;
	  pt.z = p.z;
	  pt.r = p.r;
	  pt.g = p.g;
	  pt.b = p.b;
	  i++;
       //       fprintf(out,"%lf %lf %lf %d\n", p.x, p.y, p.z, rgba(p.r, p.g, p.b));
     }
     fclose(in);
     //fclose(out);
     pcl::io::savePCDFile(argv[2],*cloud,false);

     printf("conversion done\n");

}
